/*******************************************************************************
*   $FILE: main.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*----------------------------------------------------------------------------
								   ߲׏
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								  ݸٰ ̧
----------------------------------------------------------------------------*/
#include <avr/io.h>
#include <avr/interrupt.h>
#define __delay_cycles(n)		__builtin_avr_delay_cycles(n)
#define __enable_interrupt()	sei()

#include "touch_api.h"
#include "touch.h"
/*----------------------------------------------------------------------------
								 炩Ȓ萔
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ϸ
----------------------------------------------------------------------------*/

#define GET_SENSOR_STATE(SENSOR_NUMBER) qt_measure_data.qt_touch_status.sensor_states[(SENSOR_NUMBER/8)] & (1 << (SENSOR_NUMBER % 8))
#define GET_ROTOR_SLIDER_POSITION(ROTOR_SLIDER_NUMBER) qt_measure_data.qt_touch_status.rotor_slider_values[ROTOR_SLIDER_NUMBER]

/*----------------------------------------------------------------------------
									^`
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ^
----------------------------------------------------------------------------*/
extern void touch_measure();
extern void touch_init (void);
extern void init_system (void);
extern void init_timer_isr (void);
extern void set_timer_period (uint16_t);

/*----------------------------------------------------------------------------
								   \̐錾
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
									 ϸ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   Sϐ
----------------------------------------------------------------------------*/
/* msł̌v */
uint16_t qt_measurement_period_msec = QT_MEASUREMENT_PERIOD_MS;
uint16_t time_ms_inc=0;

/*----------------------------------------------------------------------------
								   Oϐ
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
								   ÓIϐ
----------------------------------------------------------------------------*/

volatile uint8_t time_to_measure_touch = 0u;	/* ڐG𑪒肷鎞Ԃ̎ɌvISRɂĐݒ肳׸ */
volatile uint16_t current_time_ms_touch = 0u;	/* vISRɂĐݒ肳錻ݎ */

/*============================================================================
O: main
------------------------------------------------------------------------------
ړI: 庰ޓ_
: Ȃ
o: Ȃ
:
============================================================================*/

int main (void)
{
	init_system();			/* νĉpA݁AޯނȂǏ */
	init_timer_isr();		/* Iɔ悤ɌvISR`Ԑݒ */
	touch_init();			/* ڐGm평 */

	for( ; ; )				/* iɌJԂ */
	{
		touch_measure();
		/* ԂdvłȂνĉpނ͂ōs܂B */
	}
}
