/*
 * \file
 *
 * \brief
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef TWI_MASTER_H_INCLUDED
#define TWI_MASTER_H_INCLUDED

/*============================ ݸٰ =======================================*/
#include "avr_compiler.h"

/*============================ ϸ ===========================================*/
//! ްڰ ڼ޽ݒvZBXMEGAްĂŋLq鎮
#define TWI_BAUD(F_SYS, F_TWI)	((F_SYS / (2 * F_TWI)) - 5)

#define CPU_SPEED				8000000
#define BAUDRATE				100000
#define TWI_BAUDSETTING			TWI_BAUD(CPU_SPEED, BAUDRATE)
#define SLAVE_ADDRESS			0x10


#define TWIM_STATUS_READY		0
#define TWIM_STATUS_BUSY		1

/*============================ ^ ===========================================*/
typedef enum TWIM_RESULT_enum
{
	TWIM_RESULT_UNKNOWN          = (0x00<<0),
	TWIM_RESULT_OK               = (0x01<<0),
	TWIM_RESULT_BUFFER_OVERFLOW  = (0x02<<0),
	TWIM_RESULT_ARBITRATION_LOST = (0x03<<0),
	TWIM_RESULT_BUS_ERROR        = (0x04<<0),
	TWIM_RESULT_NACK_RECEIVED    = (0x05<<0),
	TWIM_RESULT_FAIL             = (0x06<<0),
} TWIM_RESULT_t;

/*! \brief TWI呕uײލ\
 *
 *  TWI呕u\́BTWIւ߲AɏՕAKvȕϐێ
 */
typedef struct TWI_Master
{
	TWI_t *interface;				/*!< gp̪ւ߲ */
	register8_t address;			/*!< ]uڽ */
	register16_t bytesToWrite;		/*!< ޲Đ */
	register16_t bytesToRead;		/*!< ǂ޲Đ */
	register16_t bytesWritten;		/*!< ꂽ޲Đ */
	register16_t bytesRead;			/*!< ǂ܂ꂽ޲Đ */
	register8_t status;				/*!< Pʓ]̏ */
	register8_t result;				/*!< Pʓ]̌ */
} TWI_Master_t;

/*============================ ^ ==========================================*/
void TWI_Master_Init (void);
bool TWI_Send_Message (void);
bool TWI_Retrieve_Message (void);
void TWI_MasterInterruptHandler (void);
void TWI_MasterArbitrationLostBusErrorHandler (void);
void TWI_MasterWriteHandler (void);
void TWI_MasterReadHandler (void);
void TWI_MasterTransactionFinished (uint8_t result);

#endif
/* EOF */
